//
//  MainViewController.m
//  BatteryMonitor
//
//  Created by Alasdair Allan on 17/08/2009.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "MainViewController.h"
#import "MainView.h"
#import "BatteryMonitorAppDelegate.h"


@implementation MainViewController


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}


/*
 // Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
 - (void)viewDidLoad {
 [super viewDidLoad];
 }
 */


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */


- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller {
    
	[self dismissModalViewControllerAnimated:YES];
}


- (IBAction)showInfo {    
	
	FlipsideViewController *controller = [[FlipsideViewController alloc] initWithNibName:@"FlipsideView" bundle:nil];
	controller.delegate = self;
	
	controller.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
	[self presentModalViewController:controller animated:YES];
	
	[controller release];
}



/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidLoad {
	[super viewDidLoad];
	appDelegate = (BatteryMonitorAppDelegate *)[[UIApplication sharedApplication] delegate];

}

- (void)viewWillAppear:(BOOL)animated {
	UIDevice *device = [UIDevice currentDevice];
	device.batteryMonitoringEnabled = appDelegate.monitorBattery;

	if (device.batteryMonitoringEnabled) {
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(batteryChanged:) name:@"UIDeviceBatteryLevelDidChangeNotification" object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(batteryChanged:) name:@"UIDeviceBatteryStateDidChangeNotification" object:nil];
	} else {
	    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"UIDeviceBatteryLevelDidChangeNotification" object:nil];
	    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"UIDeviceBatteryStateDidChangeNotification" object:nil];
	}
	levelLabel.text = [self batteryLevel];
	stateLabel.text = [self batteryState:device.batteryState];

	[super viewWillAppear:animated];
	
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	[levelLabel release];
	[stateLabel release];
    [super dealloc];
}


- (void)batteryChanged:(id *)sender {
	UIDevice *device = [UIDevice currentDevice];
	levelLabel.text = [self batteryLevel];
	stateLabel.text = [self batteryState:device.batteryState];	
}

- (NSString *)batteryLevel {
	UIDevice *device = [UIDevice currentDevice];
	
	NSString *levelString = nil;
	int level = (int)(device.batteryLevel);
	if ( level == -1 ) {
		levelString = @"---%";
	} else {
		levelString = [NSString stringWithFormat:@"%i%%", level*100];
	}
	return levelString;
}

- (NSString *)batteryState:(UIDeviceBatteryState )batteryState {
	
	NSString *state = nil;
	switch (batteryState) {
		case UIDeviceBatteryStateUnknown:
			state = @"Unknown";
			break;
		case UIDeviceBatteryStateUnplugged:
			state = @"Unplugged";
			break;
		case UIDeviceBatteryStateCharging:
			state = @"Charging";
			break;
		case UIDeviceBatteryStateFull:
			state = @"Full";
			break;
		default:
			state = @"Undefined";
			break;
	}
	return state;
}

@end
