//
//  WeatherAppDelegate.m
//  Weather
//
//  Created by Alasdair Allan on 29/08/2009.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import <CoreLocation/CoreLocation.h>

#import "WeatherAppDelegate.h"
#import "MainViewController.h"
#import "WeatherForecast.h"
#import "FindNearbyPlace.h"

@implementation WeatherAppDelegate

@synthesize window;
@synthesize mainViewController;
@synthesize updateLocation;
@synthesize locationManager;

- (void)applicationDidFinishLaunching:(UIApplication *)application {
    
	// Create instance of Main View controller
	MainViewController *aController = [[MainViewController alloc] initWithNibName:@"MainView" bundle:nil];
	self.mainViewController = aController;
	[aController release];

	// Create instance of LocationManager object
	self.locationManager = [[[CLLocationManager alloc] init] autorelease];
	self.locationManager.delegate = self; 
	
	// Create instance of WeatherForecast object
	WeatherForecast *forecast = [[WeatherForecast alloc] init];
	self.mainViewController.forecast = forecast;
	[forecast release];
	
	// Set the main view
    mainViewController.view.frame = [UIScreen mainScreen].applicationFrame;
	[window addSubview:[mainViewController view]];
    [window makeKeyAndVisible];
}

- (void)dealloc {
    [mainViewController release];
	[locationManager release];
    [window release];
    [super dealloc];
}

#pragma mark CLLocationManager Methods

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
    NSLog(@"Location: %@", [newLocation description]);

	if ( newLocation != oldLocation ) {
		
	    [self.mainViewController.loadingActivityIndicator startAnimating];
	    FindNearbyPlace *find = [[FindNearbyPlace alloc] init];
	    NSString *latitude = [NSString stringWithFormat:@"%f", newLocation.coordinate.latitude];
		NSString *longitude = [NSString stringWithFormat:@"%f", newLocation.coordinate.longitude];
		[find queryServiceWithLat:latitude andLong:longitude];
	}

}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error {
	NSLog(@"Error: %@", [error description]);
}

@end
